'''
This file demonstrate how to change a gladevcp picture with a created
hal pin.
notes:
- the handler is linked to "image1" of gladevcp
- to set a filename of a picture the image1 must have the filename opion activated
- the files error_0.png, error_0.png, error_0.png must exist
'''

#---import the needed librarys---
import hal
import glib
import hal_glib
import time

from inspect import stack


#---create a variable with filenames that can be loaded index---
error_files  = ( "./Gui/error_bereit.png", 
                 "./Gui/error_haupt.png",
                 "./Gui/error_notaus.png",
                 "./Gui/error_aus.png",
                 "./Gui/error_achstemp.png",
                 "./Gui/error_motortemp.png",
                 "./Gui/error_druck.png",
                 "./Gui/error_vakuum.png",
                 "./Gui/error_referenz.png",
                 "./Gui/error_drehzahl.png",
                 "./Gui/error_fraese2_oben.png",
                 "./Gui/error_fraese2_unten.png",
                 "./Gui/error_fraese1_oben.png",
                 "./Gui/error_fraese1_unten.png",
                 "./Gui/error_fraese2_umrichter.png",
                 "./Gui/error_fraese1_umrichter.png",
                 "./Gui/error_nut_oben.png",
                 "./Gui/error_nut_unten.png",
                 "./Gui/error_hbohr1_oben.png",
                 "./Gui/error_hbohr1_unten.png",
                 "./Gui/error_nut_y.png",
                 "./Gui/error_nut_x.png",
                 "./Gui/error_gitter.png",
                 "./Gui/error_zbremse.png")
          
#---create a variable with filenames that can be loaded index---
left_files   = ( "./Gui/led_og.png", 
                 "./Gui/led_gn.png")

#---create a variable with filenames that can be loaded index---
right_files  = ( "./Gui/led_og.png", 
                 "./Gui/led_gn.png")


#---python code that is not associated with gladevcp ui's---
class OtherClass:

    #---???---
    def invisible(selfself):
        pass


#---Python Code that is associated with GladeVCP---
class HandlerClass:
    '''
    Code Bereiche fuer GladeVCP "Handler"
    '''

    #---button press event---
    def on_button_press(self,widget,data=None):
        '''
        Button Event
        '''
        #self.builder.get_object('label_status').set_label( table[ self.halcomp['message'] ] )


    #---hal pin "meldung" change event---
    def _on_message_change(self,hal_pin,data=None):
        # images mussen die eigenschaft "Dateiname" aktiviert haben
        self.builder.get_object('image_s').set_from_file( error_files[ self.halcomp['meldung'] ] )


    #---hal pin "bereit-links" change event---
    def _on_left_change(self,hal_pin,data=None):

        self.builder.get_object('image_l').set_from_file( left_files[ self.halcomp['bereit-links'] ] )


    #---hal pin "bereit-rechts" change event---
    def _on_right_change(self,hal_pin,data=None):

        self.builder.get_object('image_r').set_from_file( right_files[ self.halcomp['bereit-rechts'] ] )


    #---startup procedure---
    def __init__(self, halcomp,builder,useropts):

        #---init halcomp/ builder---        
        self.halcomp = halcomp
        self.builder = builder

        #---create a new halpins to choose an image---
        self.message_trigger = hal_glib.GPin(halcomp.newpin('meldung',  hal.HAL_U32, hal.HAL_IN))
        self.left_trigger = hal_glib.GPin(halcomp.newpin('bereit-links',  hal.HAL_BIT, hal.HAL_IN))
        self.right_trigger = hal_glib.GPin(halcomp.newpin('bereit-rechts',  hal.HAL_BIT, hal.HAL_IN))

        #---assign the message pin to the _on_message_change event---
        self.message_trigger.connect('value-changed', self._on_message_change)
        self.left_trigger.connect('value-changed', self._on_left_change)
        self.right_trigger.connect('value-changed', self._on_right_change)


#---???---
other = OtherClass()  

#---connect this handler to gladevcp instances---
def get_handlers(halcomp,builder,useropts):
    return [HandlerClass(halcomp,builder,useropts)]



